aboutsummaryrefslogtreecommitdiff
path: root/bin/plmu.sh
diff options
context:
space:
mode:
Diffstat (limited to 'bin/plmu.sh')
-rw-r--r--bin/plmu.sh23
1 files changed, 23 insertions, 0 deletions
diff --git a/bin/plmu.sh b/bin/plmu.sh
new file mode 100644
index 00000000..78778920
--- /dev/null
+++ b/bin/plmu.sh
@@ -0,0 +1,23 @@
+# Upgrade plenv modules with cpanm(1)
+
+# Set up exceptions file if it exists
+ef=$HOME/.plenv/non-cpanm-modules
+[ -e "$ef" ] || ef=/dev/null
+
+# Check that exceptions file is sorted
+if ! sort -c -- "$ef" ; then
+ printf >&2 '%s not sorted\n' "$ef"
+ exit 1
+fi
+
+# Get the list of modules; sort them in case our current locale disagrees on
+# the existing sorting
+plenv list-modules | sort |
+
+# Exclude any modules in ~/.plenv/non-cpanm-modules if it exists
+comm -23 -- - "$ef" |
+
+# Read that list of modules to upgrade and upgrade them one by one
+while read -r module ; do
+ cpanm --notest --quiet -- "$module"
+done